{-------------------------------------------------------------------------------
  :: Iczelion's PE Tutorial 2 for Delphi ::
  translated by Sunshine

  Detects a valid PE File.

  Have a look at readme.txt for further information.

  Sunshine, February 2003
-------------------------------------------------------------------------------}
program PeTutNo2;

uses
  Windows, Messages,
  commdlg, // needed for OPENFILENAME
  pelib;

{$R petutno2.res}

var
  ofn : OPENFILENAME;
  filterstring : LPCTSTR =
                 'Executable Files (*.exe, *.dll)'+#0+'*.exe;*.dll'+#0+
                 'All Files (*.*)'+#0+'*.*'+#0+#0;
  buffer : Pointer;

  MyFile   : THandle;
  hmapping : THandle;
  pmapping : Pointer;
  pdosh    : PIMAGE_DOS_HEADER;
  peh      : PIMAGE_NT_HEADERS;

begin
  ofn.lStructSize := sizeof(ofn);
  ofn.lpstrFilter := filterstring;
  ofn.lpstrFile := @buffer;
  ofn.nMaxFile :=  512;
  ofn.lpstrTitle := 'Choose File...';
  ofn.Flags := OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or
               OFN_EXPLORER or OFN_HIDEREADONLY;

  if Getopenfilename(ofn) then
    begin
    MyFile := CreateFileA((@buffer), GENERIC_READ, FILE_SHARE_READ, nil,
                          OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);

    hmapping := CreateFileMapping(MyFile, nil, PAGE_READONLY, 0, 0, nil);
    pmapping := MapViewOfFile(hMapping, FILE_MAP_READ,0 , 0, 0);
    pdosh :=  PIMAGE_DOS_HEADER(pmapping);
    peh:= PIMAGE_NT_HEADERS(Longword(pdosh) + Longword(pdosh.e_lfanew));
    if (pdosh.e_magic = IMAGE_DOS_SIGNATURE) and (peh.Signature = IMAGE_NT_SIGNATURE)
    then
         Messagebox(0,'This file is a valid PE!','PE Tut No.2',MB_ICONINFORMATION)
    else
         Messagebox(0,'This file is NOT a valid PE!','PE Tut No.2',MB_ICONINFORMATION);
    end;

  UnMapViewofFile(pmapping);
  CloseHandle(hmapping);
  CloseHandle(MyFile);
end.
